diff --git a/src/main/java/net/minecraft/core/block/BlockLayerSlate.java b/src/main/java/net/minecraft/core/block/SlateLayerBlock.java
similarity index 69%
rename from src/main/java/net/minecraft/core/block/BlockLayerSlate.java
rename to src/main/java/net/minecraft/core/block/SlateLayerBlock.java
index 8acf62348..ef6ffe989 100644
--- a/src/main/java/net/minecraft/core/block/BlockLayerSlate.java
+++ b/src/main/java/net/minecraft/core/block/SlateLayerBlock.java
@@ -1,20 +1,21 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
-public class BlockLayerSlate extends BlockLayerBase 
+
+public class SlateLayerBlock extends BaseLayerBlock
 {
-	public BlockLayerSlate(String key, int id, Material material)
+	public SlateLayerBlock(String key, String namespaceId, int id, Material material)
 	{
-		super(key, id, material);
+		super(key, namespaceId, id, material);
 	}
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
diff --git a/src/main/java/net/minecraft/core/block/SlipperyBlock.java b/src/main/java/net/minecraft/core/block/SlipperyBlock.java
new file mode 100644
index 000000000..804b2880b
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/SlipperyBlock.java
@@ -0,0 +1,11 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+
+public class SlipperyBlock extends Block {
+
+    public SlipperyBlock(String key, String namespaceId, int id, Material material) {
+        super(key, namespaceId, id, material);
+        friction = 0.98F;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockSnow.java b/src/main/java/net/minecraft/core/block/SnowBlock.java
similarity index 75%
rename from src/main/java/net/minecraft/core/block/BlockSnow.java
rename to src/main/java/net/minecraft/core/block/SnowBlock.java
index 773f4df29..9eaca196e 100644
--- a/src/main/java/net/minecraft/core/block/BlockSnow.java
+++ b/src/main/java/net/minecraft/core/block/SnowBlock.java
@@ -1,8 +1,8 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
@@ -14,12 +14,12 @@ import java.util.Random;
 //            Block, Material, Item, EnumSkyBlock, 
 //            World
 
-public class BlockSnow extends Block
+public class SnowBlock extends Block
 {
 
-	public BlockSnow(String key, int id)
+	public SnowBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.snow);
+        super(key, namespaceId, id, Material.snow);
         setTicking(true);
     }
 
@@ -39,7 +39,7 @@ public class BlockSnow extends Block
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -47,7 +47,7 @@ public class BlockSnow extends Block
             case SILK_TOUCH:
                 return new ItemStack[] { new ItemStack(this) };
             default:
-                return new ItemStack[] { new ItemStack(Item.ammoSnowball, 4) };
+                return new ItemStack[] { new ItemStack(Items.AMMO_SNOWBALL, 4) };
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockLayerSnow.java b/src/main/java/net/minecraft/core/block/SnowLayerBlock.java
similarity index 84%
rename from src/main/java/net/minecraft/core/block/BlockLayerSnow.java
rename to src/main/java/net/minecraft/core/block/SnowLayerBlock.java
index 4dda1042c..e03309eb7 100644
--- a/src/main/java/net/minecraft/core/block/BlockLayerSnow.java
+++ b/src/main/java/net/minecraft/core/block/SnowLayerBlock.java
@@ -1,8 +1,8 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
@@ -14,15 +14,15 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, World, AxisAlignedBB, 
-//            IBlockAccess, Item, EntityItem, ItemStack, 
-//            StatList, EntityPlayer, EnumSkyBlock
+//            IBlockAccess, Item, ItemEntity, ItemStack,
+//            StatList, Player, EnumSkyBlock
 
-public class BlockLayerSnow extends BlockLayerBase
+public class SnowLayerBlock extends BaseLayerBlock
 {
 
-	public BlockLayerSnow(String key, int id, Material material)
+	public SnowLayerBlock(String key, String namespaceId, int id, Material material)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
         setTicking(true);
     }
@@ -32,7 +32,7 @@ public class BlockLayerSnow extends BlockLayerBase
     {
         int l = world.getBlockMetadata(x, y, z) & 7;
         float f = (float)(2 * (1 + l)) / 16F;
-        return AABB.getBoundingBoxFromPool((double) x + minX, (double) y + minY, (double) z + minZ, (double) x + maxX, (float) y + f - 0.125F, (double) z + maxZ);
+        return AABB.getTemporaryBB((double) x + minX, (double) y + minY, (double) z + minZ, (double) x + maxX, (float) y + f - 0.125F, (double) z + maxZ);
     }
 
     public void accumulate(World world, int x, int y, int z)
@@ -57,7 +57,7 @@ public class BlockLayerSnow extends BlockLayerBase
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
         int l = world.getBlockId(x, y - 1, z);
-        if(l == 0 || (!Block.blocksList[l].isSolidRender() && !(Block.blocksList[l] instanceof BlockLeavesBase)))
+        if(l == 0 || (!Block.blocksList[l].isSolidRender() && !(Block.blocksList[l] instanceof BaseLeavesBlock)))
         {
         	return false;
         }
@@ -88,7 +88,7 @@ public class BlockLayerSnow extends BlockLayerBase
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -98,7 +98,7 @@ public class BlockLayerSnow extends BlockLayerBase
                 return new ItemStack[] { new ItemStack(this) };
             case EXPLOSION:
             case PROPER_TOOL:
-                return new ItemStack[] { new ItemStack(Item.ammoSnowball, meta + 1) };
+                return new ItemStack[] { new ItemStack(Items.AMMO_SNOWBALL, meta + 1) };
             default:
                 return null;
         }
diff --git a/src/main/java/net/minecraft/core/block/BlockSoulSand.java b/src/main/java/net/minecraft/core/block/SoulSandBlock.java
similarity index 74%
rename from src/main/java/net/minecraft/core/block/BlockSoulSand.java
rename to src/main/java/net/minecraft/core/block/SoulSandBlock.java
index 40419ab71..756f9b62c 100644
--- a/src/main/java/net/minecraft/core/block/BlockSoulSand.java
+++ b/src/main/java/net/minecraft/core/block/SoulSandBlock.java
@@ -11,19 +11,19 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockSoulSand extends Block
+public class SoulSandBlock extends Block
 {
 
-    public BlockSoulSand(String key, int id)
+    public SoulSandBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.sand);
+        super(key, namespaceId, id, Material.sand);
     }
 
     @Override
 	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         float f = 0.125F;
-        return AABB.getBoundingBoxFromPool(x, y, z, x + 1, (float)(y + 1) - f, z + 1);
+        return AABB.getTemporaryBB(x, y, z, x + 1, (float)(y + 1) - f, z + 1);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/BlockSpikes.java b/src/main/java/net/minecraft/core/block/SpikesBlock.java
similarity index 73%
rename from src/main/java/net/minecraft/core/block/BlockSpikes.java
rename to src/main/java/net/minecraft/core/block/SpikesBlock.java
index ac1610170..b9446e445 100644
--- a/src/main/java/net/minecraft/core/block/BlockSpikes.java
+++ b/src/main/java/net/minecraft/core/block/SpikesBlock.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
@@ -18,24 +18,24 @@ import net.minecraft.core.world.WorldSource;
 //            World, AxisAlignedBB
 
 //TODO make it not extend blockWeb
-public class BlockSpikes extends BlockCobweb
+public class SpikesBlock extends CobwebBlock
 {
 
-    public BlockSpikes(String key, int id, Material mat)
+    public SpikesBlock(String key, String namespaceId, int id, Material mat)
     {
-        super(key, id, mat);
+        super(key, namespaceId, id, mat);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
-        return new ItemStack[] { new ItemStack(Block.spikes) };
+        return new ItemStack[] { new ItemStack(Blocks.SPIKES) };
     }
 
     @Override
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
-        return world.canPlaceOnSurfaceOfBlock(x, y -1, z) || world.getBlockId(x, y - 1, z) == Block.mobspawner.id;
+        return world.canPlaceOnSurfaceOfBlock(x, y -1, z) || world.getBlockId(x, y - 1, z) == Blocks.MOBSPAWNER.id;
     }
 
 	@Override
@@ -44,7 +44,7 @@ public class BlockSpikes extends BlockCobweb
 			return;
 		}
 		
-		boolean destroy = !world.canPlaceOnSurfaceOfBlock(x, y - 1, z) && world.getBlockId(x, y - 1, z) != Block.mesh.id && world.getBlockId(x, y - 1, z) != Block.mobspawner.id;
+		boolean destroy = !world.canPlaceOnSurfaceOfBlock(x, y - 1, z) && world.getBlockId(x, y - 1, z) != Blocks.MESH.id && world.getBlockId(x, y - 1, z) != Blocks.MOBSPAWNER.id;
 		if(destroy) {
 			dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
 			world.setBlockWithNotify(x, y, z, 0);
@@ -70,7 +70,7 @@ public class BlockSpikes extends BlockCobweb
 	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {	
     	float f = 1.0f / 16.0f;
-        return AABB.getBoundingBoxFromPool(x + f, y, z + f, x + 1 - f, y + 0.1875F, z + 1 - f);
+        return AABB.getTemporaryBB(x + f, y, z + f, x + 1 - f, y + 0.1875F, z + 1 - f);
     }
 
     @Override
@@ -78,9 +78,9 @@ public class BlockSpikes extends BlockCobweb
     {
         int metaData = world.getBlockMetadata(x, y, z);
         if(isSpikesUp(metaData)) {
-            if (entity instanceof EntityLiving) {
+            if (entity instanceof Mob) {
                 if(entity.fallDistance > 1.5F) {
-                    entity.hurt(null, (MathHelper.floor_double(entity.fallDistance) * 2) + 1, DamageType.COMBAT);
+                    entity.hurt(null, (MathHelper.floor(entity.fallDistance) * 2) + 1, DamageType.COMBAT);
                     entity.stuck = true;
                 } else if (entity.isWalking){
                     entity.hurt(null, 1, DamageType.COMBAT);
@@ -91,7 +91,7 @@ public class BlockSpikes extends BlockCobweb
 
     @Override
     public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
-        return !(entity instanceof EntityItem);
+        return !(entity instanceof ItemEntity);
     }
     
     public static boolean isSpikesUp(int i)
diff --git a/src/main/java/net/minecraft/core/block/BlockSpinifex.java b/src/main/java/net/minecraft/core/block/SpinifexBlock.java
similarity index 68%
rename from src/main/java/net/minecraft/core/block/BlockSpinifex.java
rename to src/main/java/net/minecraft/core/block/SpinifexBlock.java
index 28b14cf8d..c01be71cb 100644
--- a/src/main/java/net/minecraft/core/block/BlockSpinifex.java
+++ b/src/main/java/net/minecraft/core/block/SpinifexBlock.java
@@ -1,26 +1,25 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockFlower, Block
+//            FlowerBlock, Block
 
-public class BlockSpinifex extends BlockFlower
+public class SpinifexBlock extends FlowerBlock
 {
 
-	public BlockSpinifex(String key, int id)
+	public SpinifexBlock(String key, String namespaceId, int id)
     {
-        super(key, id);
+        super(key, namespaceId, id);
         float f = 0.4F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, 0.8F, 0.5F + f);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
diff --git a/src/main/java/net/minecraft/core/block/BlockSponge.java b/src/main/java/net/minecraft/core/block/SpongeBlock.java
similarity index 88%
rename from src/main/java/net/minecraft/core/block/BlockSponge.java
rename to src/main/java/net/minecraft/core/block/SpongeBlock.java
index 01c82464e..6507c428d 100644
--- a/src/main/java/net/minecraft/core/block/BlockSponge.java
+++ b/src/main/java/net/minecraft/core/block/SpongeBlock.java
@@ -10,22 +10,22 @@ import net.minecraft.core.world.Dimension;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
-public class BlockSponge extends Block
+public class SpongeBlock extends Block
 {
 
-	public BlockSponge(String key, int id, boolean isWet)
+	public SpongeBlock(String key, String namespaceId, int id, boolean isWet)
     {
-        super(key, id, Material.sponge);
+        super(key, namespaceId, id, Material.sponge);
         this.isWet = isWet;
     }
 
     @Override
-	public void onBlockAdded(World world, int x, int y, int z)
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
-        super.onBlockAdded(world, x, y, z);
+        super.onBlockPlacedByWorld(world, x, y, z);
         byte byte0 = 2;
         if(world.dimension.id == Dimension.nether.id && isWet){
-            world.setBlockWithNotify(x, y, z, Block.spongeDry.id);
+            world.setBlockWithNotify(x, y, z, Blocks.SPONGE_DRY.id);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5D, y + 0.5D, z + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
             for(int l = 0; l < 8; l++)
             {
diff --git a/src/main/java/net/minecraft/core/block/BlockStairs.java b/src/main/java/net/minecraft/core/block/StairsBlock.java
similarity index 84%
rename from src/main/java/net/minecraft/core/block/BlockStairs.java
rename to src/main/java/net/minecraft/core/block/StairsBlock.java
index d0ebaaf7c..c4bf69798 100644
--- a/src/main/java/net/minecraft/core/block/BlockStairs.java
+++ b/src/main/java/net/minecraft/core/block/StairsBlock.java
@@ -3,11 +3,12 @@ package net.minecraft.core.block;
 import java.util.ArrayList;
 import java.util.Random;
 
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.material.MaterialColor;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
@@ -17,11 +18,11 @@ import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 
 // Referenced classes of package net.minecraft.src:
-//            Block, World, EntityLiving, MathHelper, 
-//            IBlockAccess, AxisAlignedBB, EntityPlayer, Entity, 
+//            Block, World, Mob, MathHelper,
+//            IBlockAccess, AxisAlignedBB, Player, Entity,
 //            Vec3D
 
-public class BlockStairs extends Block
+public class StairsBlock extends Block
 {
 //    private static final Map<Integer, BoundingVolume> selectionVolumes = new HashMap<>();
 //
@@ -84,9 +85,9 @@ public class BlockStairs extends Block
 //        selectionVolumes.put(0b1011, vol);
 //    }
 
-	public BlockStairs(Block block, int id)
+	public StairsBlock(Block block, String namespaceId, int id)
     {
-        super("stairs." + block.key.substring(5), id, block.blockMaterial);
+        super("stairs." + block.key.substring(5), namespaceId, id, block.blockMaterial);
         modelBlock = block;
         withHardness(block.blockHardness);
         withBlastResistance(block.blastResistance / 3F);
@@ -112,7 +113,7 @@ public class BlockStairs extends Block
     }
 
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
@@ -161,9 +162,9 @@ public class BlockStairs extends Block
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
-        ItemStack[] result = modelBlock.getBreakResult(world, dropCause, x, y, z, 0, tileEntity);
+        ItemStack[] result = modelBlock.getBreakResult(world, dropCause, x, y, z, 0, blockEntity);
 
         if (result != null)
         {
@@ -181,13 +182,13 @@ public class BlockStairs extends Block
     }
 
     @Override
-	public void randomDisplayTick(World world, int x, int y, int z, Random rand)
+	public void animationTick(World world, int x, int y, int z, Random rand)
     {
-        modelBlock.randomDisplayTick(world, x, y, z, rand);
+        modelBlock.animationTick(world, x, y, z, rand);
     }
 
     @Override
-    public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit)
+    public void onBlockLeftClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit)
     {
         modelBlock.onBlockLeftClicked(world, x, y, z, player, side, xHit, yHit);
     }
@@ -205,15 +206,15 @@ public class BlockStairs extends Block
     }
 
     @Override
-    public int getRenderBlockPass()
+    public int getRenderLayer()
     {
-        return modelBlock.getRenderBlockPass();
+        return modelBlock.getRenderLayer();
     }
 
     @Override
-    public int tickRate()
+    public int tickDelay()
     {
-        return modelBlock.tickRate();
+        return modelBlock.tickDelay();
     }
 
     @Override
@@ -230,7 +231,7 @@ public class BlockStairs extends Block
 //    }
 
     @Override
-    public void handleEntityInside(World world, int x, int y, int z, Entity entity, Vec3d entityVelocity)
+    public void handleEntityInside(World world, int x, int y, int z, Entity entity, Vec3 entityVelocity)
     {
         modelBlock.handleEntityInside(world, x, y, z, entity, entityVelocity);
     }
@@ -254,10 +255,10 @@ public class BlockStairs extends Block
     }
 
     @Override
-	public void onBlockAdded(World world, int x, int y, int z)
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
         onNeighborBlockChange(world, x, y, z, 0);
-        modelBlock.onBlockAdded(world, x, y, z);
+        modelBlock.onBlockPlacedByWorld(world, x, y, z);
     }
 
     @Override
@@ -273,7 +274,7 @@ public class BlockStairs extends Block
     }
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         return modelBlock.onBlockRightClicked(world, x, y, z, player, side, xPlaced, yPlaced);
     }
@@ -285,18 +286,18 @@ public class BlockStairs extends Block
     }
     
     @Override
-    public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
 //    	System.out.println("Placed Side: "+side+" Height: "+sideHeight);
     	
         int meta = world.getBlockMetadata(x, y, z) & 0xF0;
 
-        Direction hRotation = entity.getHorizontalPlacementDirection(side).getOpposite();
+        Direction hRotation = mob.getHorizontalPlacementDirection(side).getOpposite();
         if(hRotation == Direction.NORTH) meta |= 0b0010;
         if(hRotation == Direction.EAST) meta |= 0b0001;
         if(hRotation == Direction.SOUTH) meta |= 0b0011;
         if(hRotation == Direction.WEST) meta |= 0b0000;
 
-        Direction vRotation = entity.getVerticalPlacementDirection(side, sideHeight);
+        Direction vRotation = mob.getVerticalPlacementDirection(side, sideHeight);
         if (vRotation == Direction.DOWN) meta |= 0b0000;
         if (vRotation == Direction.UP) meta |= 0b1000;
 
@@ -308,5 +309,9 @@ public class BlockStairs extends Block
     	return 0.0f;
     }
 
+    @Override
+    public MaterialColor getMaterialColor(){
+        return modelBlock.getMaterialColor();
+    }
     public Block modelBlock;
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockFluidStill.java b/src/main/java/net/minecraft/core/block/StillFluidBlock.java
similarity index 58%
rename from src/main/java/net/minecraft/core/block/BlockFluidStill.java
rename to src/main/java/net/minecraft/core/block/StillFluidBlock.java
index 49a414f84..3b8b57696 100644
--- a/src/main/java/net/minecraft/core/block/BlockFluidStill.java
+++ b/src/main/java/net/minecraft/core/block/StillFluidBlock.java
@@ -5,17 +5,12 @@ import java.util.Random;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-
-// Referenced classes of package net.minecraft.src:
-//            BlockFluid, Material, World, Block, 
-//            BlockFire
-
-public class BlockFluidStill extends BlockFluid
+public class StillFluidBlock extends FluidBlock
 {
 
-	public BlockFluidStill(String key, int id, Material material)
+	public StillFluidBlock(String key, String namespaceId, int id, Material material)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
         setTicking(false);
         if(material == Material.lava)
         {
@@ -30,17 +25,17 @@ public class BlockFluidStill extends BlockFluid
         if (blockId == Side.TOP.getId()) return;
         if(world.getBlockId(x, y, z) == id)
         {
-            func_30004_j(world, x, y, z);
+            setFlowing(world, x, y, z);
         }
     }
 
-    private void func_30004_j(World world, int i, int j, int k)
+    private void setFlowing(World world, int i, int j, int k)
     {
         int l = world.getBlockMetadata(i, j, k);
         world.editingBlocks = true;
         world.setBlockAndMetadata(i, j, k, id - 1, l);
         world.markBlocksDirty(i, j, k, i, j, k);
-        world.scheduleBlockUpdate(i, j, k, id - 1, tickRate());
+        world.scheduleBlockUpdate(i, j, k, id - 1, tickDelay());
         world.editingBlocks = false;
     }
 
@@ -55,17 +50,17 @@ public class BlockFluidStill extends BlockFluid
                 x += rand.nextInt(3) - 1;
                 y++;
                 z += rand.nextInt(3) - 1;
-                int j1 = world.getBlockId(x, y, z);
-                if(j1 == 0)
+                int blockId = world.getBlockId(x, y, z);
+                if(blockId == 0)
                 {
-                    if(func_301_k(world, x - 1, y, z) || func_301_k(world, x + 1, y, z) || func_301_k(world, x, y, z - 1) || func_301_k(world, x, y, z + 1) || func_301_k(world, x, y - 1, z) || func_301_k(world, x, y + 1, z))
+                    if(isFlammable(world, x - 1, y, z) || isFlammable(world, x + 1, y, z) || isFlammable(world, x, y, z - 1) || isFlammable(world, x, y, z + 1) || isFlammable(world, x, y - 1, z) || isFlammable(world, x, y + 1, z))
                     {
-                        world.setBlockWithNotify(x, y, z, Block.fire.id);
+                        world.setBlockWithNotify(x, y, z, Blocks.FIRE.id);
                         return;
                     }
                     continue;
                 }
-                if(Block.blocksList[j1].blockMaterial.blocksMotion())
+                if(Block.blocksList[blockId].blockMaterial.blocksMotion())
                 {
                     return;
                 }
@@ -74,8 +69,8 @@ public class BlockFluidStill extends BlockFluid
         }
     }
 
-    private boolean func_301_k(World world, int i, int j, int k)
+    private boolean isFlammable(World world, int x, int y, int z)
     {
-        return world.getBlockMaterial(i, j, k).isFlammable();
+        return FireBlock.canBurn(world, x, y, z);
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockStone.java b/src/main/java/net/minecraft/core/block/StoneBlock.java
similarity index 57%
rename from src/main/java/net/minecraft/core/block/BlockStone.java
rename to src/main/java/net/minecraft/core/block/StoneBlock.java
index a6495a688..8b005717c 100644
--- a/src/main/java/net/minecraft/core/block/BlockStone.java
+++ b/src/main/java/net/minecraft/core/block/StoneBlock.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.achievement.AchievementList;
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.achievement.stat.StatList;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
@@ -13,13 +13,13 @@ import net.minecraft.core.world.chunk.Chunk;
 import java.util.Random;
 import java.util.function.Supplier;
 
-public class BlockStone extends Block {
+public class StoneBlock extends Block {
 	
 	public Block cobblestone;
 	private final Supplier<Block> blockSupplier;
-	
-	public BlockStone(String key, int id, Supplier<Block> cobbleStoneSupplier) {
-		super(key, id, Material.stone);
+
+	public StoneBlock(String key, String namespaceId, int id, Supplier<Block> cobbleStoneSupplier, Material material) {
+		super(key, namespaceId, id, material);
 		this.blockSupplier = cobbleStoneSupplier;
 	}
 
@@ -28,18 +28,18 @@ public class BlockStone extends Block {
 		this.cobblestone = blockSupplier.get();
 	}
 	@Override
-	public void harvestBlock(World world, EntityPlayer player, int x, int y, int z, int meta, TileEntity tileEntity)
+	public void harvestBlock(World world, Player player, int x, int y, int z, int meta, BlockEntity blockEntity)
 	{
-		super.harvestBlock(world, player, x, y, z, meta, tileEntity);
-		if(player.getStat(StatList.mineBlockStatArray[Block.basalt.id]) > 0
-				&& player.getStat(StatList.mineBlockStatArray[Block.limestone.id]) > 0
-				&& player.getStat(StatList.mineBlockStatArray[Block.granite.id]) > 0) {
-			player.triggerAchievement(AchievementList.COLLECT_STONE);
+		super.harvestBlock(world, player, x, y, z, meta, blockEntity);
+		if(player.getStat(Blocks.BASALT.getStat(StatList.STAT_MINED)) > 0
+				&& player.getStat(Blocks.BASALT.getStat(StatList.STAT_MINED)) > 0
+				&& player.getStat(Blocks.BASALT.getStat(StatList.STAT_MINED)) > 0) {
+			player.triggerAchievement(Achievements.COLLECT_STONE);
 		}
 	}
 
 	@Override
-	public void randomDisplayTick(World world, int x, int y, int z, Random rand) {
+	public void animationTick(World world, int x, int y, int z, Random rand) {
 
         Chunk chunk = world.getChunkFromBlockCoords(x, z);
 		if (y <= 32 && chunk.getChunkRandom(0x3ad8025fL).nextInt(10) == 0 && world.getBlockId(x, y - 1, z) == 0) {
@@ -49,7 +49,7 @@ public class BlockStone extends Block {
 	}
 
 	@Override
-	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
 	{
 		switch (dropCause)
 		{
